import "mod_text"
import "mod_key"
import "mod_video"
import "mod_mouse"
import "mod_map"
import "mod_joy"
import "mod_screen"

global
  string s1 = "SYSINFO";
end

///////////////////////////////////////////////////////////////////////////////
function draw_joystate( )
local
  int i, j, dx, dy, t, yy;
  string zz;
end
begin
    yy = 30;
    for( i = 0; i<5 ; i++ )
      zz = i+") ";
      for( j = 0; j<16 ; j++ )
	zz += joy_getbutton ( i, j );
      end
      zz += " | ";
      zz += joy_getaxis ( i, 0 ) + " ";
      zz += joy_getaxis ( i, 1 ) + " ";
      zz += joy_getaxis ( i, 2 ) + " ";
      zz += joy_getaxis ( i, 3 ) + " ";
      zz += " | ";
      t = joy_getball ( i , &dx , &dy);
      zz += t+" ("+dx+","+dy+") ";
      zz += joy_gethat( i )+" ";
      write( 0, 0, yy+=10, 0, zz );
    end
      zz = "KEY: ";
      for( i=0; i<255; i++ )
	if( key(i) ) zz += i+" "; end
      end
      write( 0, 0, yy+=10, 0, zz );

end

/////////////////////////////////////////////////////////////////////////////// 
process main()
local
  int m;
end
begin
  set_mode ( 320, 240, 16 );
  
  s1 = "OS:" + os_id + " C:" +COMPILER_VERSION+" V:"+__VERSION__;
  
  loop
    delete_text( ALL_TEXT );
    draw_joystate( );
    write( 0, 160, 15 ,  4, s1 );
    frame;
    if( mouse.left )  break; end;
  end;
  
  m = screen_get();
  png_save( 0, m ,"report.png");

end
